package my.MyActivityDiagram.core.advice;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.common.core.command.ICommand;
import org.eclipse.gmf.runtime.emf.type.core.ElementTypeRegistry;
import org.eclipse.gmf.runtime.emf.type.core.commands.ConfigureElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.edithelper.AbstractEditHelperAdvice;
import org.eclipse.gmf.runtime.emf.type.core.requests.ConfigureRequest;
import org.eclipse.papyrus.uml.tools.utils.NamedElementUtil;
import org.eclipse.uml2.uml.InitialNode;

public class InitialNodeEditHelperAdvice extends AbstractEditHelperAdvice {

	ElementTypeRegistry reg;

	public InitialNodeEditHelperAdvice() {
		reg = ElementTypeRegistry.getInstance();
	}

//	@Override
//	public boolean approveRequest(IEditCommandRequest request) {	
//		if (request instanceof CreateElementRequest) {//GetEditContextRequest) {
//			CreateElementRequest createElementRequest = ((CreateElementRequest) request);
//			IElementType elementType = createElementRequest.getElementType();
//			EObject container = createElementRequest.getContainer();
//
//			return false;
//		}
//		return super.approveRequest(request);
//	}

//	/**
//	 * @see org.eclipse.gmf.runtime.emf.type.core.edithelper.AbstractEditHelperAdvice#getBeforeConfigureCommand(org.eclipse.gmf.runtime.emf.type.core.requests.ConfigureRequest)
//	 *
//	 * @param request
//	 * @return
//	 */
//	@Override
//	protected ICommand getBeforeConfigureCommand(ConfigureRequest request) {
//		final InitialNode elementToConfigure = (InitialNode) request.getElementToConfigure();
////		final String name = NamedElementUtil.getDefaultNameWithIncrementFromBase(InitialNode, elementToConfigure.eContainer().eContents());
//
//		return new ConfigureElementCommand(request) {
//			private IProgressMonitor progressMonitor;
//			private IAdaptable info;
//
//			@Override
//			protected CommandResult doExecuteWithResult(IProgressMonitor progressMonitor, IAdaptable info) throws ExecutionException {
//				this.progressMonitor = progressMonitor;
//				this.info = info;
//
//				IHintedType x = (IHintedType) reg.getType("org.eclipse.papyrus.uml.InitialNode");
//    			if (x != null) {
//					EClass eClass = x.getEClass();
//					System.out.println(eClass.getName());
//				}
//
//				return CommandResult.newOKCommandResult(elementToConfigure);
//			}
//		};
//	}

	@Override
	protected ICommand getAfterConfigureCommand(final ConfigureRequest request) {
		return new ConfigureElementCommand(request) {
			InitialNode elementToConfigure = (InitialNode) request.getElementToConfigure();
			@Override
			protected CommandResult doExecuteWithResult(IProgressMonitor progressMonitor, IAdaptable info) throws ExecutionException {
				elementToConfigure.unsetName();
				String initializedName = NamedElementUtil.getDefaultNameWithIncrementFromBase("InitialNode", elementToConfigure.eContainer().eContents(), elementToConfigure, "");
				elementToConfigure.setName(initializedName);
				return CommandResult.newOKCommandResult(elementToConfigure);
			}
		};
	}
}
